



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring Boot实战：拦截器与过滤器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring Boot实战：拦截器与过滤器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 23:54:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、拦截器与过滤器</strong></p>
<p>　　在讲Spring boot之前，我们先了解一下过滤器和拦截器。这两者在功能方面很类似，但是在具体技术实现方面，差距还是比较大的。在分析两者的区别之前，我们先理解一下AOP的概念，AOP不是一种具体的技术，而是一种编程思想。在面向对象编程的过程中，我们很容易通过继承、多态来解决纵向扩展。&nbsp;但是对于横向的功能，比如，在所有的service方法中开启事务，或者统一记录日志等功能，面向对象的是无法解决的。所以AOP&mdash;&mdash;面向切面编程其实是面向对象编程思想的一个补充。而我们今天讲的过滤器和拦截器都属于面向切面编程的具体实现。而两者的主要区别包括以下几个方面：</p>
<p>　　1、Filter是依赖于Servlet容器，属于Servlet规范的一部分，而拦截器则是独立存在的，可以在任何情况下使用。</p>
<p>　　2、Filter的执行由Servlet容器回调完成，而拦截器通常通过动态代理的方式来执行。</p>
<p>　　3、Filter的生命周期由Servlet容器管理，而拦截器则可以通过IoC容器来管理，因此可以通过注入等方式来获取其他Bean的实例，因此使用会更方便。</p>
<p><strong>二、过滤器的配置</strong></p>
<p>　　现在我们通过过滤器来实现记录请求执行时间的功能，其实现如下：</p>
<div>
<pre class="prettyprint linenums">public class LogCostFilter implements Filter {<br />
    @Override<br />
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override<br />
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {<br />
        long start = System.currentTimeMillis();<br />
        filterChain.doFilter(servletRequest,servletResponse);<br />
        System.out.println("Execute cost="+(System.currentTimeMillis()-start));<br />
    }

    @Override<br />
    public void destroy() {

    }<br />
}
</pre>
</div>
<p>　　这段代码的逻辑比较简单，就是在方法执行前先记录时间戳，然后通过过滤器链完成请求的执行，在返回结果之间计算执行的时间。这里需要主要，这个类必须继承Filter类，这个是Servlet的规范，这个跟以前的Web项目没区别。但是，有了过滤器类以后，以前的web项目可以在web.xml中进行配置，但是spring boot项目并没有web.xml这个文件，那怎么配置？在Spring boot中，我们需要FilterRegistrationBean来完成配置。其实现过程如下：</p>
<div>
<pre class="prettyprint linenums">@Configuration<br />
public class FilterConfig {

    @Bean<br />
    public FilterRegistrationBean registFilter() {<br />
        FilterRegistrationBean registration = new FilterRegistrationBean();<br />
        registration.setFilter(new LogCostFilter());<br />
        registration.addUrlPatterns("/*");<br />
        registration.setName("LogCostFilter");<br />
        registration.setOrder(1);<br />
        return registration;<br />
    }

}
</pre>
</div>
<p>　　这样配置就完成了，需要配置的选项主要包括实例化Filter类，然后指定url的匹配模式，设置过滤器名称和执行顺序，这个过程和在web.xml中配置其实没什么区别，只是形式不同而已。现在我们可以启动服务器访问任意URL：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/820406/201801/820406-20180129231150312-465693715.png" /></p>
<p>　　大家可以看到上面的配置已经生效了。除了通过&nbsp;FilterRegistrationBean 来配置以外，还有一种更直接的办法，直接通过注解就可以完成了：</p>
<div>
<pre class="prettyprint linenums">@WebFilter(urlPatterns = "/*", filterName = "logFilter2")<br />
public class LogCostFilter2 implements Filter {<br />
    @Override<br />
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override<br />
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {<br />
        long start = System.currentTimeMillis();<br />
        filterChain.doFilter(servletRequest, servletResponse);<br />
        System.out.println("LogFilter2 Execute cost=" + (System.currentTimeMillis() - start));<br />
    }

    @Override<br />
    public void destroy() {

    }<br />
}
</pre>
</div>
<p>　　这里直接用@WebFilter就可以进行配置，同样，可以设置url匹配模式，过滤器名称等。这里需要注意一点的是@WebFilter这个注解是Servlet3.0的规范，并不是Spring boot提供的。除了这个注解以外，我们还需在配置类中加另外一个注解：@ServletComponetScan，指定扫描的包。</p>
<div>
<pre class="prettyprint linenums">@SpringBootApplication<br />
@MapperScan("com.pandy.blog.dao")<br />
@ServletComponentScan("com.pandy.blog.filters")<br />
public class Application {<br />
    public static void main(String[] args) throws Exception {<br />
        SpringApplication.run(Application.class, args);<br />
    }<br />
}
</pre>
</div>
<p>　　现在，我们再来访问一下任意URL：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/820406/201801/820406-20180129232130046-1905239306.png" /></p>
<p>　　可以看到，我们配置的两个过滤器都生效了。细心的读者会发现，第二个Filter我们并没有指定执行的顺序，但是却在第一个Filter之前执行。这里需要解释一下，@WebFilter这个注解并没有指定执行顺序的属性，其执行顺序依赖于Filter的名称，是根据Filter类名（注意不是配置的filter的名字）的字母顺序倒序排列，并且@WebFilter指定的过滤器优先级都高于FilterRegistrationBean配置的过滤器。有兴趣的朋友可以自己实验一下。</p>
<p><strong>三、拦截器的配置</strong></p>
<p>　　上面我们已经介绍了过滤器的配置方法，接下来我们再来看看如何配置一个拦截器。我们使用拦截器来实现上面同样的功能，记录请求的执行时间。首先我们实现拦截器类：</p>
<div>
<pre class="prettyprint linenums">public class LogCostInterceptor implements HandlerInterceptor {<br />
    long start = System.currentTimeMillis();<br />
    @Override<br />
    public boolean preHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o) throws Exception {<br />
        start = System.currentTimeMillis();<br />
        return true;<br />
    }

    @Override<br />
    public void postHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, ModelAndView modelAndView) throws Exception {<br />
        System.out.println("Interceptor cost="+(System.currentTimeMillis()-start));<br />
    }

    @Override<br />
    public void afterCompletion(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, Exception e) throws Exception {<br />
    }<br />
}
</pre>
</div>
<p>　　这里我们需要实现HandlerInterceptor这个接口，这个接口包括三个方法，preHandle是请求执行前执行的，postHandler是请求结束执行的，但只有preHandle方法返回true的时候才会执行，afterCompletion是视图渲染完成后才执行，同样需要preHandle返回true，该方法通常用于清理资源等工作。除了实现上面的接口外，我们还需对其进行配置：</p>
<div>
<pre class="prettyprint linenums">@Configuration<br />
public class InterceptorConfig extends WebMvcConfigurerAdapter {

    @Override<br />
    public void addInterceptors(InterceptorRegistry registry) {<br />
        registry.addInterceptor(new LogCostInterceptor()).addPathPatterns("/**");<br />
        super.addInterceptors(registry);<br />
    }<br />
}
</pre>
</div>
<p>　　这里我们继承了WebMVCConfigurerAdapter，看过前面的文章的朋友应该已经见过这个类了，在进行静态资源目录配置的时候我们用到过这个类。这里我们重写了addInterceptors这个方法，进行拦截器的配置，主要配置项就两个，一个是指定拦截器，第二个是指定拦截的URL。现在我们再启动系统访问任意一个URL：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/820406/201801/820406-20180130003851859-2140257073.png" /></p>
<p>　　可以看到，我们通过拦截器实现了同样的功能。不过这里还要说明一点的是，其实这个实现是有问题的，因为preHandle和postHandle是两个方法，所以我们这里不得不设置一个共享变量start来存储开始值，但是这样就会存在线程安全问题。当然，我们可以通过其他方法来解决，比如通过ThreadLocal就可以很好的解决这个问题，有兴趣的同学可以自己实现。不过通过这一点我们其实可以看到，虽然拦截器在很多场景下优于过滤器，但是在这种场景下，过滤器比拦截器实现起来更简单。</p>
<p><strong>四、总结</strong></p>
<p>　　本文主要对基于Spring boot对过滤器和拦截器的配置进行的讲解。无论是过滤器还是拦截器都属于AOP（面向切面编程）思想的具体实现。除了这两种实现我们还见过另一种更灵活的AOP实现技术，即Aspect，我们可以通过Aspect来完成更多更强大的功能。这个后续再给大家分享。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q266jw9.html">【原】css实现两端对齐的3种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/390nxomq.html">iOS 关于iphone6 和 iphone6 plus 的适配</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elk5kq.html">poj 3463 最短路与次短路的方案数求解</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy7gxdq.html">表格制作模块xlwt</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd5j4y8.html">中小型数据库 RMAN CATALOG 备份恢复方案&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjr6pz9.html">包装 request Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w754vq.html">如何显示Mac OS X上的隐藏文件和文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ne608.html">python简单爬虫技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkgg0z8.html">JDBC编程-优化程序（六）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp7w0zq.html">&period;NET常用第三方库（包）总结（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r55314q.html">Linux编程 14 文件权限&lpar;用户列表passwd，用户控制shadow，useradd模板与useradd命令参数介绍&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll5rdeq.html">asp&period;net mvc自动压缩文件，并生成CDN引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2r26rq.html">linux查看磁盘大小df命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j2m55q.html">使用JavaScript修改浏览器URL地址栏的实现代码【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw1k079.html">实例化和设置一个优秀的php对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyynjvdq.html">100个MySQL 的调节和优化的提示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvew1zo9.html">Visual Studio 2017正式版离线安装方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odkz3eq.html">用Jmeter制造软件测试数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd1lv1q.html">css3动画（animation）效果2-旋转的星球</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2x2wxx9.html">python框架Scrapy报错TypeError&colon; &amp;&num;39&semi;float&amp;&num;39&semi; object is not iterable解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96p4r2v8.html">SQL2005 到 SQL2008R2 发布订阅----发布&apos;xxxxx&apos;的初始快照尚不可用。</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m1gdj8.html">Python 词云分析周杰伦《晴天》</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kd3529.html">IndentationError&colon; unexpected indent</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpdxp79.html">JS 监听微信、支付宝等移动app及浏览器的返回、后退、上一页按钮的事件方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j6o0o8.html">用eNSP模拟</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j6rkl8.html">sql server存储过程实现批量删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyxd3j9.html">easyHOOK socket send recv</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoxgevq.html">从 0 到 1，Java Web 网站架构搭建的技术演进</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meze3oq.html">【JavaScript   实现倒计时&lpar;天、时、分、秒&rpar;】</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mlmwn8.html">使用socket搭建一个网络聊天室</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
